import sys
from math import pow
from utility.ErrorUtility import ErrorUtility
errHandler=ErrorUtility.getInstance()

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable

class TypeCheckUtility:
  instance=None #private
        
  def __init__(self, debug=1):
    if TypeCheckUtility.instance!=None:
      r=RunTimeError("Singleton TypeCheckUtility is already instantiated")
      errHandler.exceptionRaised(r)
    self.debug=debug
  
  def getInstance():
    if TypeCheckUtility.instance==None:
      TypeCheckUtility.instance=TypeCheckUtility()
    return TypeCheckUtility.instance
  getInstance=Callable(getInstance)
          
  def typeCheck(self, args, types): 
    """
      Function used in debug mode to type check
      arguments of functions, since it is not native
      in python
    """   
    if len(args)!=len(types): 
      v=ValueError("typeCheck expects list of same length")
      errHandler.exceptionRaised(v)
    for argIndex in xrange(len(args)):
      if not isinstance(args[argIndex],types[argIndex]):
        msg= " method was called with invalid types!\n"+\
                  str(args[argIndex])+" is not of type "+\
                  str(types[argIndex])+"\n"
        t=TypeError(msg)
        errHandler.exceptionRaised(t)   
        
      
      

      
  
  
    